/* THIS FILE WAS AUTOMATICALLY GENERATED.  DO NOT MODIFY! */
/* generated from the file: meep.scm */

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "ctl-io.h"

#ifdef CXX_CTL_IO
using namespace ctlio;
#endif

/******* Input variables *******/
char* ctlio::epsilon_input_file;
integer ctlio::dimensions;
material_type ctlio::default_material;
vector3 ctlio::geometry_center;
lattice ctlio::geometry_lattice;
geometric_object_list ctlio::geometry;
boolean ctlio::ensure_periodicity;

/******* Output variables *******/

int ctlio::num_read_input_vars = 0; /* # calls to read_input_vars */
int ctlio::num_write_output_vars = 0; /* # calls to read_input_vars */

/******* class input functions *******/

void ctlio::near2far_region_input(SCM so, near2far_region *o)
{
o->center = vector3_object_property(so, "center");
o->size = vector3_object_property(so, "size");
o->direction = integer_object_property(so, "direction");
o->weight = cnumber_object_property(so, "weight");
}

void ctlio::force_region_input(SCM so, force_region *o)
{
o->center = vector3_object_property(so, "center");
o->size = vector3_object_property(so, "size");
o->direction = integer_object_property(so, "direction");
o->weight = cnumber_object_property(so, "weight");
}

void ctlio::energy_region_input(SCM so, energy_region *o)
{
o->center = vector3_object_property(so, "center");
o->size = vector3_object_property(so, "size");
o->direction = integer_object_property(so, "direction");
o->weight = cnumber_object_property(so, "weight");
}

void ctlio::flux_region_input(SCM so, flux_region *o)
{
o->center = vector3_object_property(so, "center");
o->size = vector3_object_property(so, "size");
o->direction = integer_object_property(so, "direction");
o->weight = cnumber_object_property(so, "weight");
}

void ctlio::eigenmode_source_input(SCM so, eigenmode_source *o)
{
o->eig_lattice_size = vector3_object_property(so, "eig-lattice-size");
o->eig_lattice_center = vector3_object_property(so, "eig-lattice-center");
o->component = integer_object_property(so, "component");
o->direction = integer_object_property(so, "direction");
o->eig_band = integer_object_property(so, "eig-band");
o->eig_kpoint = vector3_object_property(so, "eig-kpoint");
o->eig_match_freqp = boolean_object_property(so, "eig-match-freq?");
o->eig_parity = integer_object_property(so, "eig-parity");
o->eig_resolution = integer_object_property(so, "eig-resolution");
o->eig_tolerance = number_object_property(so, "eig-tolerance");
}

void ctlio::source_input(SCM so, source *o)
{
src_time_input(object_object_property(so, "src"), &o->src);
o->component = integer_object_property(so, "component");
o->center = vector3_object_property(so, "center");
o->size = vector3_object_property(so, "size");
o->amplitude = cnumber_object_property(so, "amplitude");
o->amp_func = SCM_object_property(so, "amp-func");
if (object_is_member("eigenmode-source", so)) {
o->which_subclass = source::EIGENMODE_SOURCE;
o->subclass.eigenmode_source_data = (new eigenmode_source);
eigenmode_source_input(so, o->subclass.eigenmode_source_data);
}
else 
o->which_subclass = source::SOURCE_SELF;
}

void ctlio::custom_src_input(SCM so, custom_src *o)
{
o->src_func = function_object_property(so, "src-func");
o->start_time = number_object_property(so, "start-time");
o->end_time = number_object_property(so, "end-time");
o->swigval = SCM_object_property(so, "swigval");
}

void ctlio::gaussian_src_input(SCM so, gaussian_src *o)
{
o->frequency = number_object_property(so, "frequency");
o->width = number_object_property(so, "width");
o->start_time = number_object_property(so, "start-time");
o->cutoff = number_object_property(so, "cutoff");
o->swigval = SCM_object_property(so, "swigval");
}

void ctlio::continuous_src_input(SCM so, continuous_src *o)
{
o->frequency = number_object_property(so, "frequency");
o->start_time = number_object_property(so, "start-time");
o->end_time = number_object_property(so, "end-time");
o->width = number_object_property(so, "width");
o->cutoff = number_object_property(so, "cutoff");
o->swigval = SCM_object_property(so, "swigval");
}

void ctlio::src_time_input(SCM so, src_time *o)
{
o->is_integratedp = boolean_object_property(so, "is-integrated?");
if (object_is_member("custom-src", so)) {
o->which_subclass = src_time::CUSTOM_SRC;
o->subclass.custom_src_data = (new custom_src);
custom_src_input(so, o->subclass.custom_src_data);
}
else if (object_is_member("gaussian-src", so)) {
o->which_subclass = src_time::GAUSSIAN_SRC;
o->subclass.gaussian_src_data = (new gaussian_src);
gaussian_src_input(so, o->subclass.gaussian_src_data);
}
else if (object_is_member("continuous-src", so)) {
o->which_subclass = src_time::CONTINUOUS_SRC;
o->subclass.continuous_src_data = (new continuous_src);
continuous_src_input(so, o->subclass.continuous_src_data);
}
else 
o->which_subclass = src_time::SRC_TIME_SELF;
}

void ctlio::volume_class_input(SCM so, volume_class *o)
{
o->center = vector3_object_property(so, "center");
o->size = vector3_object_property(so, "size");
}

void ctlio::absorber_input(SCM so, absorber *o)
{
}

void ctlio::pml_input(SCM so, pml *o)
{
o->thickness = number_object_property(so, "thickness");
o->direction = integer_object_property(so, "direction");
o->side = integer_object_property(so, "side");
o->strength = number_object_property(so, "strength");
o->R_asymptotic = number_object_property(so, "R-asymptotic");
o->mean_stretch = number_object_property(so, "mean-stretch");
o->pml_profile = function_object_property(so, "pml-profile");
if (object_is_member("absorber", so)) {
o->which_subclass = pml::ABSORBER;
o->subclass.absorber_data = (new absorber);
absorber_input(so, o->subclass.absorber_data);
}
else 
o->which_subclass = pml::PML_SELF;
}

void ctlio::mirror_sym_input(SCM so, mirror_sym *o)
{
}

void ctlio::rotate4_sym_input(SCM so, rotate4_sym *o)
{
}

void ctlio::rotate2_sym_input(SCM so, rotate2_sym *o)
{
}

void ctlio::symmetry_input(SCM so, symmetry *o)
{
o->direction = integer_object_property(so, "direction");
o->phase = cnumber_object_property(so, "phase");
if (object_is_member("mirror-sym", so)) {
o->which_subclass = symmetry::MIRROR_SYM;
o->subclass.mirror_sym_data = (new mirror_sym);
mirror_sym_input(so, o->subclass.mirror_sym_data);
}
else if (object_is_member("rotate4-sym", so)) {
o->which_subclass = symmetry::ROTATE4_SYM;
o->subclass.rotate4_sym_data = (new rotate4_sym);
rotate4_sym_input(so, o->subclass.rotate4_sym_data);
}
else if (object_is_member("rotate2-sym", so)) {
o->which_subclass = symmetry::ROTATE2_SYM;
o->subclass.rotate2_sym_data = (new rotate2_sym);
rotate2_sym_input(so, o->subclass.rotate2_sym_data);
}
else 
o->which_subclass = symmetry::SYMMETRY_SELF;
}

void ctlio::multilevel_atom_input(SCM so, multilevel_atom *o)
{
{
list lo_t = list_object_property(so, "initial-populations");
int i_t;
o->initial_populations.num_items = list_length(lo_t);
o->initial_populations.items = (new number[o->initial_populations.num_items]);
for (i_t = 0; i_t < o->initial_populations.num_items; i_t++) {
o->initial_populations.items[i_t] = number_list_ref(lo_t, i_t);
}
}
{
list lo_t = list_object_property(so, "transitions");
int i_t;
o->transitions.num_items = list_length(lo_t);
o->transitions.items = (new transition[o->transitions.num_items]);
for (i_t = 0; i_t < o->transitions.num_items; i_t++) {
transition_input(object_list_ref(lo_t, i_t), &o->transitions.items[i_t]);
}
}
}

void ctlio::transition_input(SCM so, transition *o)
{
o->from_level = integer_object_property(so, "from-level");
o->to_level = integer_object_property(so, "to-level");
o->transition_rate = number_object_property(so, "transition-rate");
o->frequency = number_object_property(so, "frequency");
o->sigma_diag = vector3_object_property(so, "sigma-diag");
o->gamma = number_object_property(so, "gamma");
o->pumping_rate = number_object_property(so, "pumping-rate");
}

void ctlio::lattice_input(SCM so, lattice *o)
{
o->basis1 = vector3_object_property(so, "basis1");
o->basis2 = vector3_object_property(so, "basis2");
o->basis3 = vector3_object_property(so, "basis3");
o->size = vector3_object_property(so, "size");
o->basis_size = vector3_object_property(so, "basis-size");
o->b1 = vector3_object_property(so, "b1");
o->b2 = vector3_object_property(so, "b2");
o->b3 = vector3_object_property(so, "b3");
o->basis = matrix3x3_object_property(so, "basis");
o->metric = matrix3x3_object_property(so, "metric");
}

void ctlio::ellipsoid_input(SCM so, ellipsoid *o)
{
o->inverse_semi_axes = vector3_object_property(so, "inverse-semi-axes");
}

void ctlio::prism_input(SCM so, prism *o)
{
{
list lo_t = list_object_property(so, "vertices");
int i_t;
o->vertices.num_items = list_length(lo_t);
o->vertices.items = (new vector3[o->vertices.num_items]);
for (i_t = 0; i_t < o->vertices.num_items; i_t++) {
o->vertices.items[i_t] = vector3_list_ref(lo_t, i_t);
}
}
o->height = number_object_property(so, "height");
o->axis = vector3_object_property(so, "axis");
o->sidewall_angle = number_object_property(so, "sidewall_angle");
{
list lo_t = list_object_property(so, "vertices_p");
int i_t;
o->vertices_p.num_items = list_length(lo_t);
o->vertices_p.items = (new vector3[o->vertices_p.num_items]);
for (i_t = 0; i_t < o->vertices_p.num_items; i_t++) {
o->vertices_p.items[i_t] = vector3_list_ref(lo_t, i_t);
}
}
{
list lo_t = list_object_property(so, "top_polygon_diff_vectors_p");
int i_t;
o->top_polygon_diff_vectors_p.num_items = list_length(lo_t);
o->top_polygon_diff_vectors_p.items = (new vector3[o->top_polygon_diff_vectors_p.num_items]);
for (i_t = 0; i_t < o->top_polygon_diff_vectors_p.num_items; i_t++) {
o->top_polygon_diff_vectors_p.items[i_t] = vector3_list_ref(lo_t, i_t);
}
}
{
list lo_t = list_object_property(so, "top_polygon_diff_vectors_scaled_p");
int i_t;
o->top_polygon_diff_vectors_scaled_p.num_items = list_length(lo_t);
o->top_polygon_diff_vectors_scaled_p.items = (new vector3[o->top_polygon_diff_vectors_scaled_p.num_items]);
for (i_t = 0; i_t < o->top_polygon_diff_vectors_scaled_p.num_items; i_t++) {
o->top_polygon_diff_vectors_scaled_p.items[i_t] = vector3_list_ref(lo_t, i_t);
}
}
{
list lo_t = list_object_property(so, "vertices_top_p");
int i_t;
o->vertices_top_p.num_items = list_length(lo_t);
o->vertices_top_p.items = (new vector3[o->vertices_top_p.num_items]);
for (i_t = 0; i_t < o->vertices_top_p.num_items; i_t++) {
o->vertices_top_p.items[i_t] = vector3_list_ref(lo_t, i_t);
}
}
{
list lo_t = list_object_property(so, "vertices_top");
int i_t;
o->vertices_top.num_items = list_length(lo_t);
o->vertices_top.items = (new vector3[o->vertices_top.num_items]);
for (i_t = 0; i_t < o->vertices_top.num_items; i_t++) {
o->vertices_top.items[i_t] = vector3_list_ref(lo_t, i_t);
}
}
o->centroid = vector3_object_property(so, "centroid");
{
list lo_t = list_object_property(so, "workspace");
int i_t;
o->workspace.num_items = list_length(lo_t);
o->workspace.items = (new number[o->workspace.num_items]);
for (i_t = 0; i_t < o->workspace.num_items; i_t++) {
o->workspace.items[i_t] = number_list_ref(lo_t, i_t);
}
}
o->m_c2p = matrix3x3_object_property(so, "m_c2p");
o->m_p2c = matrix3x3_object_property(so, "m_p2c");
}

void ctlio::block_input(SCM so, block *o)
{
o->e1 = vector3_object_property(so, "e1");
o->e2 = vector3_object_property(so, "e2");
o->e3 = vector3_object_property(so, "e3");
o->size = vector3_object_property(so, "size");
o->projection_matrix = matrix3x3_object_property(so, "projection-matrix");
if (object_is_member("ellipsoid", so)) {
o->which_subclass = block::ELLIPSOID;
o->subclass.ellipsoid_data = (new ellipsoid);
ellipsoid_input(so, o->subclass.ellipsoid_data);
}
else 
o->which_subclass = block::BLOCK_SELF;
}

void ctlio::sphere_input(SCM so, sphere *o)
{
o->radius = number_object_property(so, "radius");
}

void ctlio::wedge_input(SCM so, wedge *o)
{
o->wedge_angle = number_object_property(so, "wedge-angle");
o->wedge_start = vector3_object_property(so, "wedge-start");
o->e1 = vector3_object_property(so, "e1");
o->e2 = vector3_object_property(so, "e2");
}

void ctlio::cone_input(SCM so, cone *o)
{
o->radius2 = number_object_property(so, "radius2");
}

void ctlio::cylinder_input(SCM so, cylinder *o)
{
o->axis = vector3_object_property(so, "axis");
o->radius = number_object_property(so, "radius");
o->height = number_object_property(so, "height");
if (object_is_member("wedge", so)) {
o->which_subclass = cylinder::WEDGE;
o->subclass.wedge_data = (new wedge);
wedge_input(so, o->subclass.wedge_data);
}
else if (object_is_member("cone", so)) {
o->which_subclass = cylinder::CONE;
o->subclass.cone_data = (new cone);
cone_input(so, o->subclass.cone_data);
}
else 
o->which_subclass = cylinder::CYLINDER_SELF;
}

void ctlio::compound_geometric_object_input(SCM so, compound_geometric_object *o)
{
{
list lo_t = list_object_property(so, "component-objects");
int i_t;
o->component_objects.num_items = list_length(lo_t);
o->component_objects.items = (new geometric_object[o->component_objects.num_items]);
for (i_t = 0; i_t < o->component_objects.num_items; i_t++) {
geometric_object_input(object_list_ref(lo_t, i_t), &o->component_objects.items[i_t]);
}
}
}

void ctlio::geometric_object_input(SCM so, geometric_object *o)
{
material_type_input(object_object_property(so, "material"), &o->material);
o->center = vector3_object_property(so, "center");
if (object_is_member("prism", so)) {
o->which_subclass = geometric_object::PRISM;
o->subclass.prism_data = (new prism);
prism_input(so, o->subclass.prism_data);
}
else if (object_is_member("block", so)) {
o->which_subclass = geometric_object::BLOCK;
o->subclass.block_data = (new block);
block_input(so, o->subclass.block_data);
}
else if (object_is_member("sphere", so)) {
o->which_subclass = geometric_object::SPHERE;
o->subclass.sphere_data = (new sphere);
sphere_input(so, o->subclass.sphere_data);
}
else if (object_is_member("cylinder", so)) {
o->which_subclass = geometric_object::CYLINDER;
o->subclass.cylinder_data = (new cylinder);
cylinder_input(so, o->subclass.cylinder_data);
}
else if (object_is_member("compound-geometric-object", so)) {
o->which_subclass = geometric_object::COMPOUND_GEOMETRIC_OBJECT;
o->subclass.compound_geometric_object_data = (new compound_geometric_object);
compound_geometric_object_input(so, o->subclass.compound_geometric_object_data);
}
else 
o->which_subclass = geometric_object::GEOMETRIC_OBJECT_SELF;
}

void ctlio::material_function_input(SCM so, material_function *o)
{
o->material_func = function_object_property(so, "material-func");
}

void ctlio::perfect_metal_input(SCM so, perfect_metal *o)
{
}

void ctlio::medium_input(SCM so, medium *o)
{
o->epsilon_diag = vector3_object_property(so, "epsilon-diag");
o->epsilon_offdiag = vector3_object_property(so, "epsilon-offdiag");
o->mu_diag = vector3_object_property(so, "mu-diag");
o->mu_offdiag = vector3_object_property(so, "mu-offdiag");
{
list lo_t = list_object_property(so, "E-susceptibilities");
int i_t;
o->E_susceptibilities.num_items = list_length(lo_t);
o->E_susceptibilities.items = (new susceptibility[o->E_susceptibilities.num_items]);
for (i_t = 0; i_t < o->E_susceptibilities.num_items; i_t++) {
susceptibility_input(object_list_ref(lo_t, i_t), &o->E_susceptibilities.items[i_t]);
}
}
{
list lo_t = list_object_property(so, "H-susceptibilities");
int i_t;
o->H_susceptibilities.num_items = list_length(lo_t);
o->H_susceptibilities.items = (new susceptibility[o->H_susceptibilities.num_items]);
for (i_t = 0; i_t < o->H_susceptibilities.num_items; i_t++) {
susceptibility_input(object_list_ref(lo_t, i_t), &o->H_susceptibilities.items[i_t]);
}
}
o->E_chi2_diag = vector3_object_property(so, "E-chi2-diag");
o->E_chi3_diag = vector3_object_property(so, "E-chi3-diag");
o->H_chi2_diag = vector3_object_property(so, "H-chi2-diag");
o->H_chi3_diag = vector3_object_property(so, "H-chi3-diag");
o->D_conductivity_diag = vector3_object_property(so, "D-conductivity-diag");
o->B_conductivity_diag = vector3_object_property(so, "B-conductivity-diag");
}

void ctlio::gyrotropic_saturated_susceptibility_input(SCM so, gyrotropic_saturated_susceptibility *o)
{
o->frequency = number_object_property(so, "frequency");
o->gamma = number_object_property(so, "gamma");
o->bias = vector3_object_property(so, "bias");
o->alpha = number_object_property(so, "alpha");
}

void ctlio::gyrotropic_drude_susceptibility_input(SCM so, gyrotropic_drude_susceptibility *o)
{
o->bias = vector3_object_property(so, "bias");
}

void ctlio::gyrotropic_lorentzian_susceptibility_input(SCM so, gyrotropic_lorentzian_susceptibility *o)
{
o->bias = vector3_object_property(so, "bias");
}

void ctlio::noisy_drude_susceptibility_input(SCM so, noisy_drude_susceptibility *o)
{
o->noise_amp = number_object_property(so, "noise-amp");
}

void ctlio::noisy_lorentzian_susceptibility_input(SCM so, noisy_lorentzian_susceptibility *o)
{
o->noise_amp = number_object_property(so, "noise-amp");
}

void ctlio::drude_susceptibility_input(SCM so, drude_susceptibility *o)
{
o->frequency = number_object_property(so, "frequency");
o->gamma = number_object_property(so, "gamma");
if (object_is_member("gyrotropic-drude-susceptibility", so)) {
o->which_subclass = drude_susceptibility::GYROTROPIC_DRUDE_SUSCEPTIBILITY;
o->subclass.gyrotropic_drude_susceptibility_data = (new gyrotropic_drude_susceptibility);
gyrotropic_drude_susceptibility_input(so, o->subclass.gyrotropic_drude_susceptibility_data);
}
else if (object_is_member("noisy-drude-susceptibility", so)) {
o->which_subclass = drude_susceptibility::NOISY_DRUDE_SUSCEPTIBILITY;
o->subclass.noisy_drude_susceptibility_data = (new noisy_drude_susceptibility);
noisy_drude_susceptibility_input(so, o->subclass.noisy_drude_susceptibility_data);
}
else 
o->which_subclass = drude_susceptibility::DRUDE_SUSCEPTIBILITY_SELF;
}

void ctlio::lorentzian_susceptibility_input(SCM so, lorentzian_susceptibility *o)
{
o->frequency = number_object_property(so, "frequency");
o->gamma = number_object_property(so, "gamma");
if (object_is_member("gyrotropic-lorentzian-susceptibility", so)) {
o->which_subclass = lorentzian_susceptibility::GYROTROPIC_LORENTZIAN_SUSCEPTIBILITY;
o->subclass.gyrotropic_lorentzian_susceptibility_data = (new gyrotropic_lorentzian_susceptibility);
gyrotropic_lorentzian_susceptibility_input(so, o->subclass.gyrotropic_lorentzian_susceptibility_data);
}
else if (object_is_member("noisy-lorentzian-susceptibility", so)) {
o->which_subclass = lorentzian_susceptibility::NOISY_LORENTZIAN_SUSCEPTIBILITY;
o->subclass.noisy_lorentzian_susceptibility_data = (new noisy_lorentzian_susceptibility);
noisy_lorentzian_susceptibility_input(so, o->subclass.noisy_lorentzian_susceptibility_data);
}
else 
o->which_subclass = lorentzian_susceptibility::LORENTZIAN_SUSCEPTIBILITY_SELF;
}

void ctlio::susceptibility_input(SCM so, susceptibility *o)
{
o->sigma_offdiag = vector3_object_property(so, "sigma-offdiag");
o->sigma_diag = vector3_object_property(so, "sigma-diag");
if (object_is_member("multilevel-atom", so)) {
o->which_subclass = susceptibility::MULTILEVEL_ATOM;
o->subclass.multilevel_atom_data = (new multilevel_atom);
multilevel_atom_input(so, o->subclass.multilevel_atom_data);
}
else if (object_is_member("gyrotropic-saturated-susceptibility", so)) {
o->which_subclass = susceptibility::GYROTROPIC_SATURATED_SUSCEPTIBILITY;
o->subclass.gyrotropic_saturated_susceptibility_data = (new gyrotropic_saturated_susceptibility);
gyrotropic_saturated_susceptibility_input(so, o->subclass.gyrotropic_saturated_susceptibility_data);
}
else if (object_is_member("drude-susceptibility", so)) {
o->which_subclass = susceptibility::DRUDE_SUSCEPTIBILITY;
o->subclass.drude_susceptibility_data = (new drude_susceptibility);
drude_susceptibility_input(so, o->subclass.drude_susceptibility_data);
}
else if (object_is_member("lorentzian-susceptibility", so)) {
o->which_subclass = susceptibility::LORENTZIAN_SUSCEPTIBILITY;
o->subclass.lorentzian_susceptibility_data = (new lorentzian_susceptibility);
lorentzian_susceptibility_input(so, o->subclass.lorentzian_susceptibility_data);
}
else 
o->which_subclass = susceptibility::SUSCEPTIBILITY_SELF;
}

void ctlio::material_type_input(SCM so, material_type *o)
{
if (object_is_member("material-function", so)) {
o->which_subclass = material_type::MATERIAL_FUNCTION;
o->subclass.material_function_data = (new material_function);
material_function_input(so, o->subclass.material_function_data);
}
else if (object_is_member("perfect-metal", so)) {
o->which_subclass = material_type::PERFECT_METAL;
o->subclass.perfect_metal_data = (new perfect_metal);
perfect_metal_input(so, o->subclass.perfect_metal_data);
}
else if (object_is_member("medium", so)) {
o->which_subclass = material_type::MEDIUM;
o->subclass.medium_data = (new medium);
medium_input(so, o->subclass.medium_data);
}
else 
o->which_subclass = material_type::MATERIAL_TYPE_SELF;
}

/******* class copy functions *******/

void ctlio::near2far_region_copy(const near2far_region *o0,near2far_region *o)
{
o->center = o0->center;
o->size = o0->size;
o->direction = o0->direction;
o->weight = o0->weight;
}

void ctlio::force_region_copy(const force_region *o0,force_region *o)
{
o->center = o0->center;
o->size = o0->size;
o->direction = o0->direction;
o->weight = o0->weight;
}

void ctlio::energy_region_copy(const energy_region *o0,energy_region *o)
{
o->center = o0->center;
o->size = o0->size;
o->direction = o0->direction;
o->weight = o0->weight;
}

void ctlio::flux_region_copy(const flux_region *o0,flux_region *o)
{
o->center = o0->center;
o->size = o0->size;
o->direction = o0->direction;
o->weight = o0->weight;
}

void ctlio::eigenmode_source_copy(const eigenmode_source *o0,eigenmode_source *o)
{
o->eig_lattice_size = o0->eig_lattice_size;
o->eig_lattice_center = o0->eig_lattice_center;
o->component = o0->component;
o->direction = o0->direction;
o->eig_band = o0->eig_band;
o->eig_kpoint = o0->eig_kpoint;
o->eig_match_freqp = o0->eig_match_freqp;
o->eig_parity = o0->eig_parity;
o->eig_resolution = o0->eig_resolution;
o->eig_tolerance = o0->eig_tolerance;
}

void ctlio::source_copy(const source *o0,source *o)
{
src_time_copy(&o0->src, &o->src);
o->component = o0->component;
o->center = o0->center;
o->size = o0->size;
o->amplitude = o0->amplitude;
o->amp_func = o0->amp_func;
if (o0->which_subclass == source::EIGENMODE_SOURCE) {
o->which_subclass = source::EIGENMODE_SOURCE;
o->subclass.eigenmode_source_data = (new eigenmode_source);
eigenmode_source_copy(o0->subclass.eigenmode_source_data, o->subclass.eigenmode_source_data);
}
else 
o->which_subclass = source::SOURCE_SELF;
}

void ctlio::custom_src_copy(const custom_src *o0,custom_src *o)
{
o->src_func = o0->src_func;
o->start_time = o0->start_time;
o->end_time = o0->end_time;
o->swigval = o0->swigval;
}

void ctlio::gaussian_src_copy(const gaussian_src *o0,gaussian_src *o)
{
o->frequency = o0->frequency;
o->width = o0->width;
o->start_time = o0->start_time;
o->cutoff = o0->cutoff;
o->swigval = o0->swigval;
}

void ctlio::continuous_src_copy(const continuous_src *o0,continuous_src *o)
{
o->frequency = o0->frequency;
o->start_time = o0->start_time;
o->end_time = o0->end_time;
o->width = o0->width;
o->cutoff = o0->cutoff;
o->swigval = o0->swigval;
}

void ctlio::src_time_copy(const src_time *o0,src_time *o)
{
o->is_integratedp = o0->is_integratedp;
if (o0->which_subclass == src_time::CUSTOM_SRC) {
o->which_subclass = src_time::CUSTOM_SRC;
o->subclass.custom_src_data = (new custom_src);
custom_src_copy(o0->subclass.custom_src_data, o->subclass.custom_src_data);
}
else if (o0->which_subclass == src_time::GAUSSIAN_SRC) {
o->which_subclass = src_time::GAUSSIAN_SRC;
o->subclass.gaussian_src_data = (new gaussian_src);
gaussian_src_copy(o0->subclass.gaussian_src_data, o->subclass.gaussian_src_data);
}
else if (o0->which_subclass == src_time::CONTINUOUS_SRC) {
o->which_subclass = src_time::CONTINUOUS_SRC;
o->subclass.continuous_src_data = (new continuous_src);
continuous_src_copy(o0->subclass.continuous_src_data, o->subclass.continuous_src_data);
}
else 
o->which_subclass = src_time::SRC_TIME_SELF;
}

void ctlio::volume_class_copy(const volume_class *o0,volume_class *o)
{
o->center = o0->center;
o->size = o0->size;
}

void ctlio::absorber_copy(const absorber *o0,absorber *o)
{
}

void ctlio::pml_copy(const pml *o0,pml *o)
{
o->thickness = o0->thickness;
o->direction = o0->direction;
o->side = o0->side;
o->strength = o0->strength;
o->R_asymptotic = o0->R_asymptotic;
o->mean_stretch = o0->mean_stretch;
o->pml_profile = o0->pml_profile;
if (o0->which_subclass == pml::ABSORBER) {
o->which_subclass = pml::ABSORBER;
o->subclass.absorber_data = (new absorber);
absorber_copy(o0->subclass.absorber_data, o->subclass.absorber_data);
}
else 
o->which_subclass = pml::PML_SELF;
}

void ctlio::mirror_sym_copy(const mirror_sym *o0,mirror_sym *o)
{
}

void ctlio::rotate4_sym_copy(const rotate4_sym *o0,rotate4_sym *o)
{
}

void ctlio::rotate2_sym_copy(const rotate2_sym *o0,rotate2_sym *o)
{
}

void ctlio::symmetry_copy(const symmetry *o0,symmetry *o)
{
o->direction = o0->direction;
o->phase = o0->phase;
if (o0->which_subclass == symmetry::MIRROR_SYM) {
o->which_subclass = symmetry::MIRROR_SYM;
o->subclass.mirror_sym_data = (new mirror_sym);
mirror_sym_copy(o0->subclass.mirror_sym_data, o->subclass.mirror_sym_data);
}
else if (o0->which_subclass == symmetry::ROTATE4_SYM) {
o->which_subclass = symmetry::ROTATE4_SYM;
o->subclass.rotate4_sym_data = (new rotate4_sym);
rotate4_sym_copy(o0->subclass.rotate4_sym_data, o->subclass.rotate4_sym_data);
}
else if (o0->which_subclass == symmetry::ROTATE2_SYM) {
o->which_subclass = symmetry::ROTATE2_SYM;
o->subclass.rotate2_sym_data = (new rotate2_sym);
rotate2_sym_copy(o0->subclass.rotate2_sym_data, o->subclass.rotate2_sym_data);
}
else 
o->which_subclass = symmetry::SYMMETRY_SELF;
}

void ctlio::multilevel_atom_copy(const multilevel_atom *o0,multilevel_atom *o)
{
{
int i_t;
o->initial_populations.num_items = o0->initial_populations.num_items;
o->initial_populations.items = (new number[o->initial_populations.num_items]);
for (i_t = 0; i_t < o->initial_populations.num_items; i_t++) {
o->initial_populations.items[i_t] = o0->initial_populations.items[i_t];
}
}
{
int i_t;
o->transitions.num_items = o0->transitions.num_items;
o->transitions.items = (new transition[o->transitions.num_items]);
for (i_t = 0; i_t < o->transitions.num_items; i_t++) {
transition_copy(&o0->transitions.items[i_t], &o->transitions.items[i_t]);
}
}
}

void ctlio::transition_copy(const transition *o0,transition *o)
{
o->from_level = o0->from_level;
o->to_level = o0->to_level;
o->transition_rate = o0->transition_rate;
o->frequency = o0->frequency;
o->sigma_diag = o0->sigma_diag;
o->gamma = o0->gamma;
o->pumping_rate = o0->pumping_rate;
}

void ctlio::lattice_copy(const lattice *o0,lattice *o)
{
o->basis1 = o0->basis1;
o->basis2 = o0->basis2;
o->basis3 = o0->basis3;
o->size = o0->size;
o->basis_size = o0->basis_size;
o->b1 = o0->b1;
o->b2 = o0->b2;
o->b3 = o0->b3;
o->basis = o0->basis;
o->metric = o0->metric;
}

void ctlio::ellipsoid_copy(const ellipsoid *o0,ellipsoid *o)
{
o->inverse_semi_axes = o0->inverse_semi_axes;
}

void ctlio::prism_copy(const prism *o0,prism *o)
{
{
int i_t;
o->vertices.num_items = o0->vertices.num_items;
o->vertices.items = (new vector3[o->vertices.num_items]);
for (i_t = 0; i_t < o->vertices.num_items; i_t++) {
o->vertices.items[i_t] = o0->vertices.items[i_t];
}
}
o->height = o0->height;
o->axis = o0->axis;
o->sidewall_angle = o0->sidewall_angle;
{
int i_t;
o->vertices_p.num_items = o0->vertices_p.num_items;
o->vertices_p.items = (new vector3[o->vertices_p.num_items]);
for (i_t = 0; i_t < o->vertices_p.num_items; i_t++) {
o->vertices_p.items[i_t] = o0->vertices_p.items[i_t];
}
}
{
int i_t;
o->top_polygon_diff_vectors_p.num_items = o0->top_polygon_diff_vectors_p.num_items;
o->top_polygon_diff_vectors_p.items = (new vector3[o->top_polygon_diff_vectors_p.num_items]);
for (i_t = 0; i_t < o->top_polygon_diff_vectors_p.num_items; i_t++) {
o->top_polygon_diff_vectors_p.items[i_t] = o0->top_polygon_diff_vectors_p.items[i_t];
}
}
{
int i_t;
o->top_polygon_diff_vectors_scaled_p.num_items = o0->top_polygon_diff_vectors_scaled_p.num_items;
o->top_polygon_diff_vectors_scaled_p.items = (new vector3[o->top_polygon_diff_vectors_scaled_p.num_items]);
for (i_t = 0; i_t < o->top_polygon_diff_vectors_scaled_p.num_items; i_t++) {
o->top_polygon_diff_vectors_scaled_p.items[i_t] = o0->top_polygon_diff_vectors_scaled_p.items[i_t];
}
}
{
int i_t;
o->vertices_top_p.num_items = o0->vertices_top_p.num_items;
o->vertices_top_p.items = (new vector3[o->vertices_top_p.num_items]);
for (i_t = 0; i_t < o->vertices_top_p.num_items; i_t++) {
o->vertices_top_p.items[i_t] = o0->vertices_top_p.items[i_t];
}
}
{
int i_t;
o->vertices_top.num_items = o0->vertices_top.num_items;
o->vertices_top.items = (new vector3[o->vertices_top.num_items]);
for (i_t = 0; i_t < o->vertices_top.num_items; i_t++) {
o->vertices_top.items[i_t] = o0->vertices_top.items[i_t];
}
}
o->centroid = o0->centroid;
{
int i_t;
o->workspace.num_items = o0->workspace.num_items;
o->workspace.items = (new number[o->workspace.num_items]);
for (i_t = 0; i_t < o->workspace.num_items; i_t++) {
o->workspace.items[i_t] = o0->workspace.items[i_t];
}
}
o->m_c2p = o0->m_c2p;
o->m_p2c = o0->m_p2c;
}

void ctlio::block_copy(const block *o0,block *o)
{
o->e1 = o0->e1;
o->e2 = o0->e2;
o->e3 = o0->e3;
o->size = o0->size;
o->projection_matrix = o0->projection_matrix;
if (o0->which_subclass == block::ELLIPSOID) {
o->which_subclass = block::ELLIPSOID;
o->subclass.ellipsoid_data = (new ellipsoid);
ellipsoid_copy(o0->subclass.ellipsoid_data, o->subclass.ellipsoid_data);
}
else 
o->which_subclass = block::BLOCK_SELF;
}

void ctlio::sphere_copy(const sphere *o0,sphere *o)
{
o->radius = o0->radius;
}

void ctlio::wedge_copy(const wedge *o0,wedge *o)
{
o->wedge_angle = o0->wedge_angle;
o->wedge_start = o0->wedge_start;
o->e1 = o0->e1;
o->e2 = o0->e2;
}

void ctlio::cone_copy(const cone *o0,cone *o)
{
o->radius2 = o0->radius2;
}

void ctlio::cylinder_copy(const cylinder *o0,cylinder *o)
{
o->axis = o0->axis;
o->radius = o0->radius;
o->height = o0->height;
if (o0->which_subclass == cylinder::WEDGE) {
o->which_subclass = cylinder::WEDGE;
o->subclass.wedge_data = (new wedge);
wedge_copy(o0->subclass.wedge_data, o->subclass.wedge_data);
}
else if (o0->which_subclass == cylinder::CONE) {
o->which_subclass = cylinder::CONE;
o->subclass.cone_data = (new cone);
cone_copy(o0->subclass.cone_data, o->subclass.cone_data);
}
else 
o->which_subclass = cylinder::CYLINDER_SELF;
}

void ctlio::compound_geometric_object_copy(const compound_geometric_object *o0,compound_geometric_object *o)
{
{
int i_t;
o->component_objects.num_items = o0->component_objects.num_items;
o->component_objects.items = (new geometric_object[o->component_objects.num_items]);
for (i_t = 0; i_t < o->component_objects.num_items; i_t++) {
geometric_object_copy(&o0->component_objects.items[i_t], &o->component_objects.items[i_t]);
}
}
}

void ctlio::geometric_object_copy(const geometric_object *o0,geometric_object *o)
{
material_type_copy(&o0->material, &o->material);
o->center = o0->center;
if (o0->which_subclass == geometric_object::PRISM) {
o->which_subclass = geometric_object::PRISM;
o->subclass.prism_data = (new prism);
prism_copy(o0->subclass.prism_data, o->subclass.prism_data);
}
else if (o0->which_subclass == geometric_object::BLOCK) {
o->which_subclass = geometric_object::BLOCK;
o->subclass.block_data = (new block);
block_copy(o0->subclass.block_data, o->subclass.block_data);
}
else if (o0->which_subclass == geometric_object::SPHERE) {
o->which_subclass = geometric_object::SPHERE;
o->subclass.sphere_data = (new sphere);
sphere_copy(o0->subclass.sphere_data, o->subclass.sphere_data);
}
else if (o0->which_subclass == geometric_object::CYLINDER) {
o->which_subclass = geometric_object::CYLINDER;
o->subclass.cylinder_data = (new cylinder);
cylinder_copy(o0->subclass.cylinder_data, o->subclass.cylinder_data);
}
else if (o0->which_subclass == geometric_object::COMPOUND_GEOMETRIC_OBJECT) {
o->which_subclass = geometric_object::COMPOUND_GEOMETRIC_OBJECT;
o->subclass.compound_geometric_object_data = (new compound_geometric_object);
compound_geometric_object_copy(o0->subclass.compound_geometric_object_data, o->subclass.compound_geometric_object_data);
}
else 
o->which_subclass = geometric_object::GEOMETRIC_OBJECT_SELF;
}

void ctlio::material_function_copy(const material_function *o0,material_function *o)
{
o->material_func = o0->material_func;
}

void ctlio::perfect_metal_copy(const perfect_metal *o0,perfect_metal *o)
{
}

void ctlio::medium_copy(const medium *o0,medium *o)
{
o->epsilon_diag = o0->epsilon_diag;
o->epsilon_offdiag = o0->epsilon_offdiag;
o->mu_diag = o0->mu_diag;
o->mu_offdiag = o0->mu_offdiag;
{
int i_t;
o->E_susceptibilities.num_items = o0->E_susceptibilities.num_items;
o->E_susceptibilities.items = (new susceptibility[o->E_susceptibilities.num_items]);
for (i_t = 0; i_t < o->E_susceptibilities.num_items; i_t++) {
susceptibility_copy(&o0->E_susceptibilities.items[i_t], &o->E_susceptibilities.items[i_t]);
}
}
{
int i_t;
o->H_susceptibilities.num_items = o0->H_susceptibilities.num_items;
o->H_susceptibilities.items = (new susceptibility[o->H_susceptibilities.num_items]);
for (i_t = 0; i_t < o->H_susceptibilities.num_items; i_t++) {
susceptibility_copy(&o0->H_susceptibilities.items[i_t], &o->H_susceptibilities.items[i_t]);
}
}
o->E_chi2_diag = o0->E_chi2_diag;
o->E_chi3_diag = o0->E_chi3_diag;
o->H_chi2_diag = o0->H_chi2_diag;
o->H_chi3_diag = o0->H_chi3_diag;
o->D_conductivity_diag = o0->D_conductivity_diag;
o->B_conductivity_diag = o0->B_conductivity_diag;
}

void ctlio::gyrotropic_saturated_susceptibility_copy(const gyrotropic_saturated_susceptibility *o0,gyrotropic_saturated_susceptibility *o)
{
o->frequency = o0->frequency;
o->gamma = o0->gamma;
o->bias = o0->bias;
o->alpha = o0->alpha;
}

void ctlio::gyrotropic_drude_susceptibility_copy(const gyrotropic_drude_susceptibility *o0,gyrotropic_drude_susceptibility *o)
{
o->bias = o0->bias;
}

void ctlio::gyrotropic_lorentzian_susceptibility_copy(const gyrotropic_lorentzian_susceptibility *o0,gyrotropic_lorentzian_susceptibility *o)
{
o->bias = o0->bias;
}

void ctlio::noisy_drude_susceptibility_copy(const noisy_drude_susceptibility *o0,noisy_drude_susceptibility *o)
{
o->noise_amp = o0->noise_amp;
}

void ctlio::noisy_lorentzian_susceptibility_copy(const noisy_lorentzian_susceptibility *o0,noisy_lorentzian_susceptibility *o)
{
o->noise_amp = o0->noise_amp;
}

void ctlio::drude_susceptibility_copy(const drude_susceptibility *o0,drude_susceptibility *o)
{
o->frequency = o0->frequency;
o->gamma = o0->gamma;
if (o0->which_subclass == drude_susceptibility::GYROTROPIC_DRUDE_SUSCEPTIBILITY) {
o->which_subclass = drude_susceptibility::GYROTROPIC_DRUDE_SUSCEPTIBILITY;
o->subclass.gyrotropic_drude_susceptibility_data = (new gyrotropic_drude_susceptibility);
gyrotropic_drude_susceptibility_copy(o0->subclass.gyrotropic_drude_susceptibility_data, o->subclass.gyrotropic_drude_susceptibility_data);
}
else if (o0->which_subclass == drude_susceptibility::NOISY_DRUDE_SUSCEPTIBILITY) {
o->which_subclass = drude_susceptibility::NOISY_DRUDE_SUSCEPTIBILITY;
o->subclass.noisy_drude_susceptibility_data = (new noisy_drude_susceptibility);
noisy_drude_susceptibility_copy(o0->subclass.noisy_drude_susceptibility_data, o->subclass.noisy_drude_susceptibility_data);
}
else 
o->which_subclass = drude_susceptibility::DRUDE_SUSCEPTIBILITY_SELF;
}

void ctlio::lorentzian_susceptibility_copy(const lorentzian_susceptibility *o0,lorentzian_susceptibility *o)
{
o->frequency = o0->frequency;
o->gamma = o0->gamma;
if (o0->which_subclass == lorentzian_susceptibility::GYROTROPIC_LORENTZIAN_SUSCEPTIBILITY) {
o->which_subclass = lorentzian_susceptibility::GYROTROPIC_LORENTZIAN_SUSCEPTIBILITY;
o->subclass.gyrotropic_lorentzian_susceptibility_data = (new gyrotropic_lorentzian_susceptibility);
gyrotropic_lorentzian_susceptibility_copy(o0->subclass.gyrotropic_lorentzian_susceptibility_data, o->subclass.gyrotropic_lorentzian_susceptibility_data);
}
else if (o0->which_subclass == lorentzian_susceptibility::NOISY_LORENTZIAN_SUSCEPTIBILITY) {
o->which_subclass = lorentzian_susceptibility::NOISY_LORENTZIAN_SUSCEPTIBILITY;
o->subclass.noisy_lorentzian_susceptibility_data = (new noisy_lorentzian_susceptibility);
noisy_lorentzian_susceptibility_copy(o0->subclass.noisy_lorentzian_susceptibility_data, o->subclass.noisy_lorentzian_susceptibility_data);
}
else 
o->which_subclass = lorentzian_susceptibility::LORENTZIAN_SUSCEPTIBILITY_SELF;
}

void ctlio::susceptibility_copy(const susceptibility *o0,susceptibility *o)
{
o->sigma_offdiag = o0->sigma_offdiag;
o->sigma_diag = o0->sigma_diag;
if (o0->which_subclass == susceptibility::MULTILEVEL_ATOM) {
o->which_subclass = susceptibility::MULTILEVEL_ATOM;
o->subclass.multilevel_atom_data = (new multilevel_atom);
multilevel_atom_copy(o0->subclass.multilevel_atom_data, o->subclass.multilevel_atom_data);
}
else if (o0->which_subclass == susceptibility::GYROTROPIC_SATURATED_SUSCEPTIBILITY) {
o->which_subclass = susceptibility::GYROTROPIC_SATURATED_SUSCEPTIBILITY;
o->subclass.gyrotropic_saturated_susceptibility_data = (new gyrotropic_saturated_susceptibility);
gyrotropic_saturated_susceptibility_copy(o0->subclass.gyrotropic_saturated_susceptibility_data, o->subclass.gyrotropic_saturated_susceptibility_data);
}
else if (o0->which_subclass == susceptibility::DRUDE_SUSCEPTIBILITY) {
o->which_subclass = susceptibility::DRUDE_SUSCEPTIBILITY;
o->subclass.drude_susceptibility_data = (new drude_susceptibility);
drude_susceptibility_copy(o0->subclass.drude_susceptibility_data, o->subclass.drude_susceptibility_data);
}
else if (o0->which_subclass == susceptibility::LORENTZIAN_SUSCEPTIBILITY) {
o->which_subclass = susceptibility::LORENTZIAN_SUSCEPTIBILITY;
o->subclass.lorentzian_susceptibility_data = (new lorentzian_susceptibility);
lorentzian_susceptibility_copy(o0->subclass.lorentzian_susceptibility_data, o->subclass.lorentzian_susceptibility_data);
}
else 
o->which_subclass = susceptibility::SUSCEPTIBILITY_SELF;
}

void ctlio::material_type_copy(const material_type *o0,material_type *o)
{
if (o0->which_subclass == material_type::MATERIAL_FUNCTION) {
o->which_subclass = material_type::MATERIAL_FUNCTION;
o->subclass.material_function_data = (new material_function);
material_function_copy(o0->subclass.material_function_data, o->subclass.material_function_data);
}
else if (o0->which_subclass == material_type::PERFECT_METAL) {
o->which_subclass = material_type::PERFECT_METAL;
o->subclass.perfect_metal_data = (new perfect_metal);
perfect_metal_copy(o0->subclass.perfect_metal_data, o->subclass.perfect_metal_data);
}
else if (o0->which_subclass == material_type::MEDIUM) {
o->which_subclass = material_type::MEDIUM;
o->subclass.medium_data = (new medium);
medium_copy(o0->subclass.medium_data, o->subclass.medium_data);
}
else 
o->which_subclass = material_type::MATERIAL_TYPE_SELF;
}

/******* class equal functions *******/

boolean ctlio::near2far_region_equal(const near2far_region *o0, const near2far_region *o)
{
if (!vector3_equal(o->center, o0->center)) return 0;
if (!vector3_equal(o->size, o0->size)) return 0;
if (o->direction != o0->direction) return 0;
if (!cnumber_equal(o->weight, o0->weight)) return 0;
;
return 1;
}

boolean ctlio::force_region_equal(const force_region *o0, const force_region *o)
{
if (!vector3_equal(o->center, o0->center)) return 0;
if (!vector3_equal(o->size, o0->size)) return 0;
if (o->direction != o0->direction) return 0;
if (!cnumber_equal(o->weight, o0->weight)) return 0;
;
return 1;
}

boolean ctlio::energy_region_equal(const energy_region *o0, const energy_region *o)
{
if (!vector3_equal(o->center, o0->center)) return 0;
if (!vector3_equal(o->size, o0->size)) return 0;
if (o->direction != o0->direction) return 0;
if (!cnumber_equal(o->weight, o0->weight)) return 0;
;
return 1;
}

boolean ctlio::flux_region_equal(const flux_region *o0, const flux_region *o)
{
if (!vector3_equal(o->center, o0->center)) return 0;
if (!vector3_equal(o->size, o0->size)) return 0;
if (o->direction != o0->direction) return 0;
if (!cnumber_equal(o->weight, o0->weight)) return 0;
;
return 1;
}

boolean ctlio::eigenmode_source_equal(const eigenmode_source *o0, const eigenmode_source *o)
{
if (!vector3_equal(o->eig_lattice_size, o0->eig_lattice_size)) return 0;
if (!vector3_equal(o->eig_lattice_center, o0->eig_lattice_center)) return 0;
if (o->component != o0->component) return 0;
if (o->direction != o0->direction) return 0;
if (o->eig_band != o0->eig_band) return 0;
if (!vector3_equal(o->eig_kpoint, o0->eig_kpoint)) return 0;
if (o->eig_match_freqp != o0->eig_match_freqp) return 0;
if (o->eig_parity != o0->eig_parity) return 0;
if (o->eig_resolution != o0->eig_resolution) return 0;
if (o->eig_tolerance != o0->eig_tolerance) return 0;
;
return 1;
}

boolean ctlio::source_equal(const source *o0, const source *o)
{
if (!src_time_equal(&o0->src, &o->src)) return 0;
if (o->component != o0->component) return 0;
if (!vector3_equal(o->center, o0->center)) return 0;
if (!vector3_equal(o->size, o0->size)) return 0;
if (!cnumber_equal(o->amplitude, o0->amplitude)) return 0;
if (o->amp_func != o0->amp_func) return 0;
if (o0->which_subclass != o->which_subclass) return 0;
if (o0->which_subclass == source::EIGENMODE_SOURCE) {
if (!eigenmode_source_equal(o0->subclass.eigenmode_source_data, o->subclass.eigenmode_source_data)) return 0;
}
else ;
return 1;
}

boolean ctlio::custom_src_equal(const custom_src *o0, const custom_src *o)
{
if (o->src_func != o0->src_func) return 0;
if (o->start_time != o0->start_time) return 0;
if (o->end_time != o0->end_time) return 0;
if (o->swigval != o0->swigval) return 0;
;
return 1;
}

boolean ctlio::gaussian_src_equal(const gaussian_src *o0, const gaussian_src *o)
{
if (o->frequency != o0->frequency) return 0;
if (o->width != o0->width) return 0;
if (o->start_time != o0->start_time) return 0;
if (o->cutoff != o0->cutoff) return 0;
if (o->swigval != o0->swigval) return 0;
;
return 1;
}

boolean ctlio::continuous_src_equal(const continuous_src *o0, const continuous_src *o)
{
if (o->frequency != o0->frequency) return 0;
if (o->start_time != o0->start_time) return 0;
if (o->end_time != o0->end_time) return 0;
if (o->width != o0->width) return 0;
if (o->cutoff != o0->cutoff) return 0;
if (o->swigval != o0->swigval) return 0;
;
return 1;
}

boolean ctlio::src_time_equal(const src_time *o0, const src_time *o)
{
if (o->is_integratedp != o0->is_integratedp) return 0;
if (o0->which_subclass != o->which_subclass) return 0;
if (o0->which_subclass == src_time::CUSTOM_SRC) {
if (!custom_src_equal(o0->subclass.custom_src_data, o->subclass.custom_src_data)) return 0;
}
else if (o0->which_subclass == src_time::GAUSSIAN_SRC) {
if (!gaussian_src_equal(o0->subclass.gaussian_src_data, o->subclass.gaussian_src_data)) return 0;
}
else if (o0->which_subclass == src_time::CONTINUOUS_SRC) {
if (!continuous_src_equal(o0->subclass.continuous_src_data, o->subclass.continuous_src_data)) return 0;
}
else ;
return 1;
}

boolean ctlio::volume_class_equal(const volume_class *o0, const volume_class *o)
{
if (!vector3_equal(o->center, o0->center)) return 0;
if (!vector3_equal(o->size, o0->size)) return 0;
;
return 1;
}

boolean ctlio::absorber_equal(const absorber *o0, const absorber *o)
{
;
return 1;
}

boolean ctlio::pml_equal(const pml *o0, const pml *o)
{
if (o->thickness != o0->thickness) return 0;
if (o->direction != o0->direction) return 0;
if (o->side != o0->side) return 0;
if (o->strength != o0->strength) return 0;
if (o->R_asymptotic != o0->R_asymptotic) return 0;
if (o->mean_stretch != o0->mean_stretch) return 0;
if (o->pml_profile != o0->pml_profile) return 0;
if (o0->which_subclass != o->which_subclass) return 0;
if (o0->which_subclass == pml::ABSORBER) {
if (!absorber_equal(o0->subclass.absorber_data, o->subclass.absorber_data)) return 0;
}
else ;
return 1;
}

boolean ctlio::mirror_sym_equal(const mirror_sym *o0, const mirror_sym *o)
{
;
return 1;
}

boolean ctlio::rotate4_sym_equal(const rotate4_sym *o0, const rotate4_sym *o)
{
;
return 1;
}

boolean ctlio::rotate2_sym_equal(const rotate2_sym *o0, const rotate2_sym *o)
{
;
return 1;
}

boolean ctlio::symmetry_equal(const symmetry *o0, const symmetry *o)
{
if (o->direction != o0->direction) return 0;
if (!cnumber_equal(o->phase, o0->phase)) return 0;
if (o0->which_subclass != o->which_subclass) return 0;
if (o0->which_subclass == symmetry::MIRROR_SYM) {
if (!mirror_sym_equal(o0->subclass.mirror_sym_data, o->subclass.mirror_sym_data)) return 0;
}
else if (o0->which_subclass == symmetry::ROTATE4_SYM) {
if (!rotate4_sym_equal(o0->subclass.rotate4_sym_data, o->subclass.rotate4_sym_data)) return 0;
}
else if (o0->which_subclass == symmetry::ROTATE2_SYM) {
if (!rotate2_sym_equal(o0->subclass.rotate2_sym_data, o->subclass.rotate2_sym_data)) return 0;
}
else ;
return 1;
}

boolean ctlio::multilevel_atom_equal(const multilevel_atom *o0, const multilevel_atom *o)
{
{
int i_t;
if (o->initial_populations.num_items != o0->initial_populations.num_items) return 0;
for (i_t = 0; i_t < o->initial_populations.num_items; i_t++) {
if (o->initial_populations.items[i_t] != o0->initial_populations.items[i_t]) return 0;
}
}
{
int i_t;
if (o->transitions.num_items != o0->transitions.num_items) return 0;
for (i_t = 0; i_t < o->transitions.num_items; i_t++) {
if (!transition_equal(&o0->transitions.items[i_t], &o->transitions.items[i_t])) return 0;
}
}
;
return 1;
}

boolean ctlio::transition_equal(const transition *o0, const transition *o)
{
if (o->from_level != o0->from_level) return 0;
if (o->to_level != o0->to_level) return 0;
if (o->transition_rate != o0->transition_rate) return 0;
if (o->frequency != o0->frequency) return 0;
if (!vector3_equal(o->sigma_diag, o0->sigma_diag)) return 0;
if (o->gamma != o0->gamma) return 0;
if (o->pumping_rate != o0->pumping_rate) return 0;
;
return 1;
}

boolean ctlio::lattice_equal(const lattice *o0, const lattice *o)
{
if (!vector3_equal(o->basis1, o0->basis1)) return 0;
if (!vector3_equal(o->basis2, o0->basis2)) return 0;
if (!vector3_equal(o->basis3, o0->basis3)) return 0;
if (!vector3_equal(o->size, o0->size)) return 0;
if (!vector3_equal(o->basis_size, o0->basis_size)) return 0;
if (!vector3_equal(o->b1, o0->b1)) return 0;
if (!vector3_equal(o->b2, o0->b2)) return 0;
if (!vector3_equal(o->b3, o0->b3)) return 0;
if (!matrix3x3_equal(o->basis, o0->basis)) return 0;
if (!matrix3x3_equal(o->metric, o0->metric)) return 0;
;
return 1;
}

boolean ctlio::ellipsoid_equal(const ellipsoid *o0, const ellipsoid *o)
{
if (!vector3_equal(o->inverse_semi_axes, o0->inverse_semi_axes)) return 0;
;
return 1;
}

boolean ctlio::prism_equal(const prism *o0, const prism *o)
{
{
int i_t;
if (o->vertices.num_items != o0->vertices.num_items) return 0;
for (i_t = 0; i_t < o->vertices.num_items; i_t++) {
if (!vector3_equal(o->vertices.items[i_t], o0->vertices.items[i_t])) return 0;
}
}
if (o->height != o0->height) return 0;
if (!vector3_equal(o->axis, o0->axis)) return 0;
if (o->sidewall_angle != o0->sidewall_angle) return 0;
{
int i_t;
if (o->vertices_p.num_items != o0->vertices_p.num_items) return 0;
for (i_t = 0; i_t < o->vertices_p.num_items; i_t++) {
if (!vector3_equal(o->vertices_p.items[i_t], o0->vertices_p.items[i_t])) return 0;
}
}
{
int i_t;
if (o->top_polygon_diff_vectors_p.num_items != o0->top_polygon_diff_vectors_p.num_items) return 0;
for (i_t = 0; i_t < o->top_polygon_diff_vectors_p.num_items; i_t++) {
if (!vector3_equal(o->top_polygon_diff_vectors_p.items[i_t], o0->top_polygon_diff_vectors_p.items[i_t])) return 0;
}
}
{
int i_t;
if (o->top_polygon_diff_vectors_scaled_p.num_items != o0->top_polygon_diff_vectors_scaled_p.num_items) return 0;
for (i_t = 0; i_t < o->top_polygon_diff_vectors_scaled_p.num_items; i_t++) {
if (!vector3_equal(o->top_polygon_diff_vectors_scaled_p.items[i_t], o0->top_polygon_diff_vectors_scaled_p.items[i_t])) return 0;
}
}
{
int i_t;
if (o->vertices_top_p.num_items != o0->vertices_top_p.num_items) return 0;
for (i_t = 0; i_t < o->vertices_top_p.num_items; i_t++) {
if (!vector3_equal(o->vertices_top_p.items[i_t], o0->vertices_top_p.items[i_t])) return 0;
}
}
{
int i_t;
if (o->vertices_top.num_items != o0->vertices_top.num_items) return 0;
for (i_t = 0; i_t < o->vertices_top.num_items; i_t++) {
if (!vector3_equal(o->vertices_top.items[i_t], o0->vertices_top.items[i_t])) return 0;
}
}
if (!vector3_equal(o->centroid, o0->centroid)) return 0;
{
int i_t;
if (o->workspace.num_items != o0->workspace.num_items) return 0;
for (i_t = 0; i_t < o->workspace.num_items; i_t++) {
if (o->workspace.items[i_t] != o0->workspace.items[i_t]) return 0;
}
}
if (!matrix3x3_equal(o->m_c2p, o0->m_c2p)) return 0;
if (!matrix3x3_equal(o->m_p2c, o0->m_p2c)) return 0;
;
return 1;
}

boolean ctlio::block_equal(const block *o0, const block *o)
{
if (!vector3_equal(o->e1, o0->e1)) return 0;
if (!vector3_equal(o->e2, o0->e2)) return 0;
if (!vector3_equal(o->e3, o0->e3)) return 0;
if (!vector3_equal(o->size, o0->size)) return 0;
if (!matrix3x3_equal(o->projection_matrix, o0->projection_matrix)) return 0;
if (o0->which_subclass != o->which_subclass) return 0;
if (o0->which_subclass == block::ELLIPSOID) {
if (!ellipsoid_equal(o0->subclass.ellipsoid_data, o->subclass.ellipsoid_data)) return 0;
}
else ;
return 1;
}

boolean ctlio::sphere_equal(const sphere *o0, const sphere *o)
{
if (o->radius != o0->radius) return 0;
;
return 1;
}

boolean ctlio::wedge_equal(const wedge *o0, const wedge *o)
{
if (o->wedge_angle != o0->wedge_angle) return 0;
if (!vector3_equal(o->wedge_start, o0->wedge_start)) return 0;
if (!vector3_equal(o->e1, o0->e1)) return 0;
if (!vector3_equal(o->e2, o0->e2)) return 0;
;
return 1;
}

boolean ctlio::cone_equal(const cone *o0, const cone *o)
{
if (o->radius2 != o0->radius2) return 0;
;
return 1;
}

boolean ctlio::cylinder_equal(const cylinder *o0, const cylinder *o)
{
if (!vector3_equal(o->axis, o0->axis)) return 0;
if (o->radius != o0->radius) return 0;
if (o->height != o0->height) return 0;
if (o0->which_subclass != o->which_subclass) return 0;
if (o0->which_subclass == cylinder::WEDGE) {
if (!wedge_equal(o0->subclass.wedge_data, o->subclass.wedge_data)) return 0;
}
else if (o0->which_subclass == cylinder::CONE) {
if (!cone_equal(o0->subclass.cone_data, o->subclass.cone_data)) return 0;
}
else ;
return 1;
}

boolean ctlio::compound_geometric_object_equal(const compound_geometric_object *o0, const compound_geometric_object *o)
{
{
int i_t;
if (o->component_objects.num_items != o0->component_objects.num_items) return 0;
for (i_t = 0; i_t < o->component_objects.num_items; i_t++) {
if (!geometric_object_equal(&o0->component_objects.items[i_t], &o->component_objects.items[i_t])) return 0;
}
}
;
return 1;
}

boolean ctlio::geometric_object_equal(const geometric_object *o0, const geometric_object *o)
{
if (!material_type_equal(&o0->material, &o->material)) return 0;
if (!vector3_equal(o->center, o0->center)) return 0;
if (o0->which_subclass != o->which_subclass) return 0;
if (o0->which_subclass == geometric_object::PRISM) {
if (!prism_equal(o0->subclass.prism_data, o->subclass.prism_data)) return 0;
}
else if (o0->which_subclass == geometric_object::BLOCK) {
if (!block_equal(o0->subclass.block_data, o->subclass.block_data)) return 0;
}
else if (o0->which_subclass == geometric_object::SPHERE) {
if (!sphere_equal(o0->subclass.sphere_data, o->subclass.sphere_data)) return 0;
}
else if (o0->which_subclass == geometric_object::CYLINDER) {
if (!cylinder_equal(o0->subclass.cylinder_data, o->subclass.cylinder_data)) return 0;
}
else if (o0->which_subclass == geometric_object::COMPOUND_GEOMETRIC_OBJECT) {
if (!compound_geometric_object_equal(o0->subclass.compound_geometric_object_data, o->subclass.compound_geometric_object_data)) return 0;
}
else ;
return 1;
}

boolean ctlio::material_function_equal(const material_function *o0, const material_function *o)
{
if (o->material_func != o0->material_func) return 0;
;
return 1;
}

boolean ctlio::perfect_metal_equal(const perfect_metal *o0, const perfect_metal *o)
{
;
return 1;
}

boolean ctlio::medium_equal(const medium *o0, const medium *o)
{
if (!vector3_equal(o->epsilon_diag, o0->epsilon_diag)) return 0;
if (!vector3_equal(o->epsilon_offdiag, o0->epsilon_offdiag)) return 0;
if (!vector3_equal(o->mu_diag, o0->mu_diag)) return 0;
if (!vector3_equal(o->mu_offdiag, o0->mu_offdiag)) return 0;
{
int i_t;
if (o->E_susceptibilities.num_items != o0->E_susceptibilities.num_items) return 0;
for (i_t = 0; i_t < o->E_susceptibilities.num_items; i_t++) {
if (!susceptibility_equal(&o0->E_susceptibilities.items[i_t], &o->E_susceptibilities.items[i_t])) return 0;
}
}
{
int i_t;
if (o->H_susceptibilities.num_items != o0->H_susceptibilities.num_items) return 0;
for (i_t = 0; i_t < o->H_susceptibilities.num_items; i_t++) {
if (!susceptibility_equal(&o0->H_susceptibilities.items[i_t], &o->H_susceptibilities.items[i_t])) return 0;
}
}
if (!vector3_equal(o->E_chi2_diag, o0->E_chi2_diag)) return 0;
if (!vector3_equal(o->E_chi3_diag, o0->E_chi3_diag)) return 0;
if (!vector3_equal(o->H_chi2_diag, o0->H_chi2_diag)) return 0;
if (!vector3_equal(o->H_chi3_diag, o0->H_chi3_diag)) return 0;
if (!vector3_equal(o->D_conductivity_diag, o0->D_conductivity_diag)) return 0;
if (!vector3_equal(o->B_conductivity_diag, o0->B_conductivity_diag)) return 0;
;
return 1;
}

boolean ctlio::gyrotropic_saturated_susceptibility_equal(const gyrotropic_saturated_susceptibility *o0, const gyrotropic_saturated_susceptibility *o)
{
if (o->frequency != o0->frequency) return 0;
if (o->gamma != o0->gamma) return 0;
if (!vector3_equal(o->bias, o0->bias)) return 0;
if (o->alpha != o0->alpha) return 0;
;
return 1;
}

boolean ctlio::gyrotropic_drude_susceptibility_equal(const gyrotropic_drude_susceptibility *o0, const gyrotropic_drude_susceptibility *o)
{
if (!vector3_equal(o->bias, o0->bias)) return 0;
;
return 1;
}

boolean ctlio::gyrotropic_lorentzian_susceptibility_equal(const gyrotropic_lorentzian_susceptibility *o0, const gyrotropic_lorentzian_susceptibility *o)
{
if (!vector3_equal(o->bias, o0->bias)) return 0;
;
return 1;
}

boolean ctlio::noisy_drude_susceptibility_equal(const noisy_drude_susceptibility *o0, const noisy_drude_susceptibility *o)
{
if (o->noise_amp != o0->noise_amp) return 0;
;
return 1;
}

boolean ctlio::noisy_lorentzian_susceptibility_equal(const noisy_lorentzian_susceptibility *o0, const noisy_lorentzian_susceptibility *o)
{
if (o->noise_amp != o0->noise_amp) return 0;
;
return 1;
}

boolean ctlio::drude_susceptibility_equal(const drude_susceptibility *o0, const drude_susceptibility *o)
{
if (o->frequency != o0->frequency) return 0;
if (o->gamma != o0->gamma) return 0;
if (o0->which_subclass != o->which_subclass) return 0;
if (o0->which_subclass == drude_susceptibility::GYROTROPIC_DRUDE_SUSCEPTIBILITY) {
if (!gyrotropic_drude_susceptibility_equal(o0->subclass.gyrotropic_drude_susceptibility_data, o->subclass.gyrotropic_drude_susceptibility_data)) return 0;
}
else if (o0->which_subclass == drude_susceptibility::NOISY_DRUDE_SUSCEPTIBILITY) {
if (!noisy_drude_susceptibility_equal(o0->subclass.noisy_drude_susceptibility_data, o->subclass.noisy_drude_susceptibility_data)) return 0;
}
else ;
return 1;
}

boolean ctlio::lorentzian_susceptibility_equal(const lorentzian_susceptibility *o0, const lorentzian_susceptibility *o)
{
if (o->frequency != o0->frequency) return 0;
if (o->gamma != o0->gamma) return 0;
if (o0->which_subclass != o->which_subclass) return 0;
if (o0->which_subclass == lorentzian_susceptibility::GYROTROPIC_LORENTZIAN_SUSCEPTIBILITY) {
if (!gyrotropic_lorentzian_susceptibility_equal(o0->subclass.gyrotropic_lorentzian_susceptibility_data, o->subclass.gyrotropic_lorentzian_susceptibility_data)) return 0;
}
else if (o0->which_subclass == lorentzian_susceptibility::NOISY_LORENTZIAN_SUSCEPTIBILITY) {
if (!noisy_lorentzian_susceptibility_equal(o0->subclass.noisy_lorentzian_susceptibility_data, o->subclass.noisy_lorentzian_susceptibility_data)) return 0;
}
else ;
return 1;
}

boolean ctlio::susceptibility_equal(const susceptibility *o0, const susceptibility *o)
{
if (!vector3_equal(o->sigma_offdiag, o0->sigma_offdiag)) return 0;
if (!vector3_equal(o->sigma_diag, o0->sigma_diag)) return 0;
if (o0->which_subclass != o->which_subclass) return 0;
if (o0->which_subclass == susceptibility::MULTILEVEL_ATOM) {
if (!multilevel_atom_equal(o0->subclass.multilevel_atom_data, o->subclass.multilevel_atom_data)) return 0;
}
else if (o0->which_subclass == susceptibility::GYROTROPIC_SATURATED_SUSCEPTIBILITY) {
if (!gyrotropic_saturated_susceptibility_equal(o0->subclass.gyrotropic_saturated_susceptibility_data, o->subclass.gyrotropic_saturated_susceptibility_data)) return 0;
}
else if (o0->which_subclass == susceptibility::DRUDE_SUSCEPTIBILITY) {
if (!drude_susceptibility_equal(o0->subclass.drude_susceptibility_data, o->subclass.drude_susceptibility_data)) return 0;
}
else if (o0->which_subclass == susceptibility::LORENTZIAN_SUSCEPTIBILITY) {
if (!lorentzian_susceptibility_equal(o0->subclass.lorentzian_susceptibility_data, o->subclass.lorentzian_susceptibility_data)) return 0;
}
else ;
return 1;
}

boolean ctlio::material_type_equal(const material_type *o0, const material_type *o)
{
if (o0->which_subclass != o->which_subclass) return 0;
if (o0->which_subclass == material_type::MATERIAL_FUNCTION) {
if (!material_function_equal(o0->subclass.material_function_data, o->subclass.material_function_data)) return 0;
}
else if (o0->which_subclass == material_type::PERFECT_METAL) {
if (!perfect_metal_equal(o0->subclass.perfect_metal_data, o->subclass.perfect_metal_data)) return 0;
}
else if (o0->which_subclass == material_type::MEDIUM) {
if (!medium_equal(o0->subclass.medium_data, o->subclass.medium_data)) return 0;
}
else ;
return 1;
}

/******* class destruction functions *******/

void ctlio::near2far_region_destroy(near2far_region o)
{
}

void ctlio::force_region_destroy(force_region o)
{
}

void ctlio::energy_region_destroy(energy_region o)
{
}

void ctlio::flux_region_destroy(flux_region o)
{
}

void ctlio::eigenmode_source_destroy(eigenmode_source o)
{
}

void ctlio::source_destroy(source o)
{
src_time_destroy(o.src);
if (o.which_subclass == source::EIGENMODE_SOURCE) {
eigenmode_source_destroy(*o.subclass.eigenmode_source_data);
delete (o.subclass.eigenmode_source_data);
}
else { }
}

void ctlio::custom_src_destroy(custom_src o)
{
}

void ctlio::gaussian_src_destroy(gaussian_src o)
{
}

void ctlio::continuous_src_destroy(continuous_src o)
{
}

void ctlio::src_time_destroy(src_time o)
{
if (o.which_subclass == src_time::CUSTOM_SRC) {
custom_src_destroy(*o.subclass.custom_src_data);
delete (o.subclass.custom_src_data);
}
else if (o.which_subclass == src_time::GAUSSIAN_SRC) {
gaussian_src_destroy(*o.subclass.gaussian_src_data);
delete (o.subclass.gaussian_src_data);
}
else if (o.which_subclass == src_time::CONTINUOUS_SRC) {
continuous_src_destroy(*o.subclass.continuous_src_data);
delete (o.subclass.continuous_src_data);
}
else { }
}

void ctlio::volume_class_destroy(volume_class o)
{
}

void ctlio::absorber_destroy(absorber o)
{
}

void ctlio::pml_destroy(pml o)
{
if (o.which_subclass == pml::ABSORBER) {
absorber_destroy(*o.subclass.absorber_data);
delete (o.subclass.absorber_data);
}
else { }
}

void ctlio::mirror_sym_destroy(mirror_sym o)
{
}

void ctlio::rotate4_sym_destroy(rotate4_sym o)
{
}

void ctlio::rotate2_sym_destroy(rotate2_sym o)
{
}

void ctlio::symmetry_destroy(symmetry o)
{
if (o.which_subclass == symmetry::MIRROR_SYM) {
mirror_sym_destroy(*o.subclass.mirror_sym_data);
delete (o.subclass.mirror_sym_data);
}
else if (o.which_subclass == symmetry::ROTATE4_SYM) {
rotate4_sym_destroy(*o.subclass.rotate4_sym_data);
delete (o.subclass.rotate4_sym_data);
}
else if (o.which_subclass == symmetry::ROTATE2_SYM) {
rotate2_sym_destroy(*o.subclass.rotate2_sym_data);
delete (o.subclass.rotate2_sym_data);
}
else { }
}

void ctlio::multilevel_atom_destroy(multilevel_atom o)
{
{
int index_t;
for (index_t = 0; index_t < o.initial_populations.num_items; index_t++) {
}
}
delete[] (o.initial_populations.items);
{
int index_t;
for (index_t = 0; index_t < o.transitions.num_items; index_t++) {
transition_destroy(o.transitions.items[index_t]);
}
}
delete[] (o.transitions.items);
}

void ctlio::transition_destroy(transition o)
{
}

void ctlio::lattice_destroy(lattice o)
{
}

void ctlio::ellipsoid_destroy(ellipsoid o)
{
}

void ctlio::prism_destroy(prism o)
{
{
int index_t;
for (index_t = 0; index_t < o.vertices.num_items; index_t++) {
}
}
delete[] (o.vertices.items);
{
int index_t;
for (index_t = 0; index_t < o.vertices_p.num_items; index_t++) {
}
}
delete[] (o.vertices_p.items);
{
int index_t;
for (index_t = 0; index_t < o.top_polygon_diff_vectors_p.num_items; index_t++) {
}
}
delete[] (o.top_polygon_diff_vectors_p.items);
{
int index_t;
for (index_t = 0; index_t < o.top_polygon_diff_vectors_scaled_p.num_items; index_t++) {
}
}
delete[] (o.top_polygon_diff_vectors_scaled_p.items);
{
int index_t;
for (index_t = 0; index_t < o.vertices_top_p.num_items; index_t++) {
}
}
delete[] (o.vertices_top_p.items);
{
int index_t;
for (index_t = 0; index_t < o.vertices_top.num_items; index_t++) {
}
}
delete[] (o.vertices_top.items);
{
int index_t;
for (index_t = 0; index_t < o.workspace.num_items; index_t++) {
}
}
delete[] (o.workspace.items);
}

void ctlio::block_destroy(block o)
{
if (o.which_subclass == block::ELLIPSOID) {
ellipsoid_destroy(*o.subclass.ellipsoid_data);
delete (o.subclass.ellipsoid_data);
}
else { }
}

void ctlio::sphere_destroy(sphere o)
{
}

void ctlio::wedge_destroy(wedge o)
{
}

void ctlio::cone_destroy(cone o)
{
}

void ctlio::cylinder_destroy(cylinder o)
{
if (o.which_subclass == cylinder::WEDGE) {
wedge_destroy(*o.subclass.wedge_data);
delete (o.subclass.wedge_data);
}
else if (o.which_subclass == cylinder::CONE) {
cone_destroy(*o.subclass.cone_data);
delete (o.subclass.cone_data);
}
else { }
}

void ctlio::compound_geometric_object_destroy(compound_geometric_object o)
{
{
int index_t;
for (index_t = 0; index_t < o.component_objects.num_items; index_t++) {
geometric_object_destroy(o.component_objects.items[index_t]);
}
}
delete[] (o.component_objects.items);
}

void ctlio::geometric_object_destroy(geometric_object o)
{
material_type_destroy(o.material);
if (o.which_subclass == geometric_object::PRISM) {
prism_destroy(*o.subclass.prism_data);
delete (o.subclass.prism_data);
}
else if (o.which_subclass == geometric_object::BLOCK) {
block_destroy(*o.subclass.block_data);
delete (o.subclass.block_data);
}
else if (o.which_subclass == geometric_object::SPHERE) {
sphere_destroy(*o.subclass.sphere_data);
delete (o.subclass.sphere_data);
}
else if (o.which_subclass == geometric_object::CYLINDER) {
cylinder_destroy(*o.subclass.cylinder_data);
delete (o.subclass.cylinder_data);
}
else if (o.which_subclass == geometric_object::COMPOUND_GEOMETRIC_OBJECT) {
compound_geometric_object_destroy(*o.subclass.compound_geometric_object_data);
delete (o.subclass.compound_geometric_object_data);
}
else { }
}

void ctlio::material_function_destroy(material_function o)
{
}

void ctlio::perfect_metal_destroy(perfect_metal o)
{
}

void ctlio::medium_destroy(medium o)
{
{
int index_t;
for (index_t = 0; index_t < o.E_susceptibilities.num_items; index_t++) {
susceptibility_destroy(o.E_susceptibilities.items[index_t]);
}
}
delete[] (o.E_susceptibilities.items);
{
int index_t;
for (index_t = 0; index_t < o.H_susceptibilities.num_items; index_t++) {
susceptibility_destroy(o.H_susceptibilities.items[index_t]);
}
}
delete[] (o.H_susceptibilities.items);
}

void ctlio::gyrotropic_saturated_susceptibility_destroy(gyrotropic_saturated_susceptibility o)
{
}

void ctlio::gyrotropic_drude_susceptibility_destroy(gyrotropic_drude_susceptibility o)
{
}

void ctlio::gyrotropic_lorentzian_susceptibility_destroy(gyrotropic_lorentzian_susceptibility o)
{
}

void ctlio::noisy_drude_susceptibility_destroy(noisy_drude_susceptibility o)
{
}

void ctlio::noisy_lorentzian_susceptibility_destroy(noisy_lorentzian_susceptibility o)
{
}

void ctlio::drude_susceptibility_destroy(drude_susceptibility o)
{
if (o.which_subclass == drude_susceptibility::GYROTROPIC_DRUDE_SUSCEPTIBILITY) {
gyrotropic_drude_susceptibility_destroy(*o.subclass.gyrotropic_drude_susceptibility_data);
delete (o.subclass.gyrotropic_drude_susceptibility_data);
}
else if (o.which_subclass == drude_susceptibility::NOISY_DRUDE_SUSCEPTIBILITY) {
noisy_drude_susceptibility_destroy(*o.subclass.noisy_drude_susceptibility_data);
delete (o.subclass.noisy_drude_susceptibility_data);
}
else { }
}

void ctlio::lorentzian_susceptibility_destroy(lorentzian_susceptibility o)
{
if (o.which_subclass == lorentzian_susceptibility::GYROTROPIC_LORENTZIAN_SUSCEPTIBILITY) {
gyrotropic_lorentzian_susceptibility_destroy(*o.subclass.gyrotropic_lorentzian_susceptibility_data);
delete (o.subclass.gyrotropic_lorentzian_susceptibility_data);
}
else if (o.which_subclass == lorentzian_susceptibility::NOISY_LORENTZIAN_SUSCEPTIBILITY) {
noisy_lorentzian_susceptibility_destroy(*o.subclass.noisy_lorentzian_susceptibility_data);
delete (o.subclass.noisy_lorentzian_susceptibility_data);
}
else { }
}

void ctlio::susceptibility_destroy(susceptibility o)
{
if (o.which_subclass == susceptibility::MULTILEVEL_ATOM) {
multilevel_atom_destroy(*o.subclass.multilevel_atom_data);
delete (o.subclass.multilevel_atom_data);
}
else if (o.which_subclass == susceptibility::GYROTROPIC_SATURATED_SUSCEPTIBILITY) {
gyrotropic_saturated_susceptibility_destroy(*o.subclass.gyrotropic_saturated_susceptibility_data);
delete (o.subclass.gyrotropic_saturated_susceptibility_data);
}
else if (o.which_subclass == susceptibility::DRUDE_SUSCEPTIBILITY) {
drude_susceptibility_destroy(*o.subclass.drude_susceptibility_data);
delete (o.subclass.drude_susceptibility_data);
}
else if (o.which_subclass == susceptibility::LORENTZIAN_SUSCEPTIBILITY) {
lorentzian_susceptibility_destroy(*o.subclass.lorentzian_susceptibility_data);
delete (o.subclass.lorentzian_susceptibility_data);
}
else { }
}

void ctlio::material_type_destroy(material_type o)
{
if (o.which_subclass == material_type::MATERIAL_FUNCTION) {
material_function_destroy(*o.subclass.material_function_data);
delete (o.subclass.material_function_data);
}
else if (o.which_subclass == material_type::PERFECT_METAL) {
perfect_metal_destroy(*o.subclass.perfect_metal_data);
delete (o.subclass.perfect_metal_data);
}
else if (o.which_subclass == material_type::MEDIUM) {
medium_destroy(*o.subclass.medium_data);
delete (o.subclass.medium_data);
}
else { }
}

/******* read input variables *******/

SCM ctlio::read_input_vars(void)
{
if (num_read_input_vars++) destroy_input_vars();
epsilon_input_file = ctl_get_string("epsilon-input-file");
dimensions = ctl_get_integer("dimensions");
material_type_input(ctl_get_object("default-material"), &default_material);
geometry_center = ctl_get_vector3("geometry-center");
lattice_input(ctl_get_object("geometry-lattice"), &geometry_lattice);
{
list lo_t = ctl_get_list("geometry");
int i_t;
geometry.num_items = list_length(lo_t);
geometry.items = (new geometric_object[geometry.num_items]);
for (i_t = 0; i_t < geometry.num_items; i_t++) {
geometric_object_input(object_list_ref(lo_t, i_t), &geometry.items[i_t]);
}
}
ensure_periodicity = ctl_get_boolean("ensure-periodicity");
return SCM_UNSPECIFIED;
}

/******* write output variables *******/

SCM ctlio::write_output_vars(void)
{
num_write_output_vars++;
return SCM_UNSPECIFIED;
}

/******* destroy input variables *******/

SCM ctlio::destroy_input_vars(void)
{
delete[] (epsilon_input_file);
material_type_destroy(default_material);
lattice_destroy(geometry_lattice);
{
int index_t;
for (index_t = 0; index_t < geometry.num_items; index_t++) {
geometric_object_destroy(geometry.items[index_t]);
}
}
delete[] (geometry.items);
return SCM_UNSPECIFIED;
}

/******* destroy output variables *******/

SCM ctlio::destroy_output_vars(void)
{
return SCM_UNSPECIFIED;
}

/******* external-functions *******/

SCM ctlio::square_basis_aux(SCM arg_scm_0, SCM arg_scm_1)
{
SCM return_val_scm;
matrix3x3 return_val_c;
matrix3x3 arg_c_0;
vector3 arg_c_1;

arg_c_0 = ctl_convert_matrix3x3_to_c(arg_scm_0);
arg_c_1 = ctl_convert_vector3_to_c(arg_scm_1);

#ifdef HAVE_SCM_FLUSH_ALL_PORTS
scm_flush_all_ports();
#endif
return_val_c = square_basis(arg_c_0, arg_c_1);

fflush(stdout); fflush(stderr);

return_val_scm = ctl_convert_matrix3x3_to_scm(return_val_c);
return return_val_scm;
}

SCM ctlio::range_overlap_with_object_aux(SCM arg_scm_0, SCM arg_scm_1, SCM arg_scm_2, SCM arg_scm_3, SCM arg_scm_4)
{
SCM return_val_scm;
number return_val_c;
vector3 arg_c_0;
vector3 arg_c_1;
geometric_object arg_c_2;
number arg_c_3;
integer arg_c_4;

arg_c_0 = ctl_convert_vector3_to_c(arg_scm_0);
arg_c_1 = ctl_convert_vector3_to_c(arg_scm_1);
geometric_object_input(ctl_convert_object_to_c(arg_scm_2), &arg_c_2);
arg_c_3 = ctl_convert_number_to_c(arg_scm_3);
arg_c_4 = ctl_convert_integer_to_c(arg_scm_4);

#ifdef HAVE_SCM_FLUSH_ALL_PORTS
scm_flush_all_ports();
#endif
return_val_c = range_overlap_with_object(arg_c_0, arg_c_1, arg_c_2, arg_c_3, arg_c_4);

fflush(stdout); fflush(stderr);
geometric_object_destroy(arg_c_2);

return_val_scm = ctl_convert_number_to_scm(return_val_c);
return return_val_scm;
}

SCM ctlio::display_geometric_object_info_aux(SCM arg_scm_0, SCM arg_scm_1)
{
integer arg_c_0;
geometric_object arg_c_1;

arg_c_0 = ctl_convert_integer_to_c(arg_scm_0);
geometric_object_input(ctl_convert_object_to_c(arg_scm_1), &arg_c_1);

#ifdef HAVE_SCM_FLUSH_ALL_PORTS
scm_flush_all_ports();
#endif
display_geometric_object_info(arg_c_0, arg_c_1);

fflush(stdout); fflush(stderr);
geometric_object_destroy(arg_c_1);

return SCM_UNSPECIFIED;
}

SCM ctlio::point_in_periodic_objectp_aux(SCM arg_scm_0, SCM arg_scm_1)
{
SCM return_val_scm;
boolean return_val_c;
vector3 arg_c_0;
geometric_object arg_c_1;

arg_c_0 = ctl_convert_vector3_to_c(arg_scm_0);
geometric_object_input(ctl_convert_object_to_c(arg_scm_1), &arg_c_1);

#ifdef HAVE_SCM_FLUSH_ALL_PORTS
scm_flush_all_ports();
#endif
return_val_c = point_in_periodic_objectp(arg_c_0, arg_c_1);

fflush(stdout); fflush(stderr);
geometric_object_destroy(arg_c_1);

return_val_scm = ctl_convert_boolean_to_scm(return_val_c);
return return_val_scm;
}

SCM ctlio::normal_to_object_aux(SCM arg_scm_0, SCM arg_scm_1)
{
SCM return_val_scm;
vector3 return_val_c;
vector3 arg_c_0;
geometric_object arg_c_1;

arg_c_0 = ctl_convert_vector3_to_c(arg_scm_0);
geometric_object_input(ctl_convert_object_to_c(arg_scm_1), &arg_c_1);

#ifdef HAVE_SCM_FLUSH_ALL_PORTS
scm_flush_all_ports();
#endif
return_val_c = normal_to_object(arg_c_0, arg_c_1);

fflush(stdout); fflush(stderr);
geometric_object_destroy(arg_c_1);

return_val_scm = ctl_convert_vector3_to_scm(return_val_c);
return return_val_scm;
}

SCM ctlio::point_in_objectp_aux(SCM arg_scm_0, SCM arg_scm_1)
{
SCM return_val_scm;
boolean return_val_c;
vector3 arg_c_0;
geometric_object arg_c_1;

arg_c_0 = ctl_convert_vector3_to_c(arg_scm_0);
geometric_object_input(ctl_convert_object_to_c(arg_scm_1), &arg_c_1);

#ifdef HAVE_SCM_FLUSH_ALL_PORTS
scm_flush_all_ports();
#endif
return_val_c = point_in_objectp(arg_c_0, arg_c_1);

fflush(stdout); fflush(stderr);
geometric_object_destroy(arg_c_1);

return_val_scm = ctl_convert_boolean_to_scm(return_val_c);
return return_val_scm;
}

void ctlio::export_external_functions(void)
{
gh_new_procedure("square-basis-aux", (SCM (*)()) square_basis_aux, 2, 0, 0);
gh_new_procedure("range-overlap-with-object-aux", (SCM (*)()) range_overlap_with_object_aux, 5, 0, 0);
gh_new_procedure("display-geometric-object-info-aux", (SCM (*)()) display_geometric_object_info_aux, 2, 0, 0);
gh_new_procedure("point-in-periodic-object?-aux", (SCM (*)()) point_in_periodic_objectp_aux, 2, 0, 0);
gh_new_procedure("normal-to-object-aux", (SCM (*)()) normal_to_object_aux, 2, 0, 0);
gh_new_procedure("point-in-object?-aux", (SCM (*)()) point_in_objectp_aux, 2, 0, 0);
}

